/* eslint-disable */
import { Button, Form, Image, Text } from '@zeedhi/common';
import { Http, IDictionary, Metadata } from '@zeedhi/core';
import { CardTitle } from '@zeedhi/teknisa-components-common';

export class QRCodeController {
  public collapseQrCode({ component }: { component: Button }) {
    // const collapse = (component.parent.parent as any).getChildInstance('col4').getChildInstance('expandedCollapse');
    const rowParent: any = component!.parent!.parent!;
    const nameCol = rowParent.children[1].name;
    const collapse = rowParent!.getChildInstance(nameCol)!.children[0];
    const selectObjectLinhaPrinter = component!.parent!.parent!.children[3];
    collapse.isVisible = !collapse.isVisible;
    selectObjectLinhaPrinter.isVisible = !selectObjectLinhaPrinter.isVisible;
  }

  // public generateQRCode({ component } : {component: Image}) {
  //   const urlSrc: string = component.src;
  //   Http.post('/getQRCode', { url: urlSrc })
  //     .then((response: IDictionary) => {
  //       let uri: string = '';
  //       ([uri] = response.data.dataset.QRCodeUri);
  //       component.src = uri;
  //     })
  //     .catch((err) => {
  //       throw err;
  //     });
  // }

  // Gera o qrcode a partir de um sourceLink
  public async generateQRCode(urlSrc: any) {
    let uri: string = '';
    await Http.post('/getQRCode', { url: urlSrc })
      .then((response: IDictionary) => {
        ([uri] = response.data.dataset.QRCodeUri);
      })
      .catch((err) => {
        throw err;
      });
    return uri;
  }

  public printQrCodeLocaisAtendimento() {
    const form = Metadata.getInstance<Form>('form-qrCode');
    const qrCode = document.getElementsByName('qRCodeImagem');

    const a = window.open('', '', 'height=724, width=948');
    a!.document.write('<html>');
    a!.document.write('<body><h1 align="center"><br>');
    a!.document.write('<p> Tipo de Local: </n>', form.value.tipoLocalAtendimento, '</p>');
    a!.document.write('<p>Local: </n>', form.value.localAtendimento, '</p>');
    a!.document.write('<div class = "container"><style>.container {justify-content: center; align-items: center; border-style: solid; border-color: black; margin: 70px;} </style>');
    a!.document.write('<p>', qrCode[0].innerHTML, '</p>');
    a!.document.write('</div>');
    a!.document.write('</body></html>');
    a!.print();
    a!.close();
  }
}
